#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './donkeyconfig.ui'
**
** Created: Thu Nov 13 01:47:39 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "donkeyconfig.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <klistbox.h>
#include <kpushbutton.h>
#include <qframe.h>
#include <klineedit.h>
#include <qlabel.h>
#include <qwidgetstack.h>
#include <qgroupbox.h>
#include <kcombobox.h>
#include <kpassdlg.h>
#include <knuminput.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "knuminput.h"
#include "kconfig.h"
#include "kguiitem.h"
#include "donkeyentry.h"
#include "kmessagebox.h"
#include "dcopclient.h"
#include "kurl.h"
#include "kdirselectdialog.h"
#include "kfiledialog.h"
#include "kpassdlg.h"
#include "kmdcodec.h"
#include "qtextcodec.h"
#include "kdebug.h"
#include "./donkeyconfig.ui.h"

/*
 *  Constructs a DonkeyConfig as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
DonkeyConfig::DonkeyConfig( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "DonkeyConfig" );
    DonkeyConfigLayout = new QVBoxLayout( this, 11, 6, "DonkeyConfigLayout"); 

    tabWidget2 = new QTabWidget( this, "tabWidget2" );

    tab = new QWidget( tabWidget2, "tab" );
    tabLayout = new QHBoxLayout( tab, 11, 6, "tabLayout"); 

    layout1 = new QVBoxLayout( 0, 0, 6, "layout1"); 

    hostList = new KListBox( tab, "hostList" );
    hostList->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)7, 1, 0, hostList->sizePolicy().hasHeightForWidth() ) );
    layout1->addWidget( hostList );

    defaultButton = new KPushButton( tab, "defaultButton" );
    layout1->addWidget( defaultButton );

    newButton = new KPushButton( tab, "newButton" );
    layout1->addWidget( newButton );

    deleteButton = new KPushButton( tab, "deleteButton" );
    layout1->addWidget( deleteButton );
    tabLayout->addLayout( layout1 );

    hostFrame = new QFrame( tab, "hostFrame" );
    hostFrame->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)7, 3, 0, hostFrame->sizePolicy().hasHeightForWidth() ) );
    hostFrame->setFrameShape( QFrame::NoFrame );
    hostFrame->setFrameShadow( QFrame::Plain );
    hostFrameLayout = new QGridLayout( hostFrame, 1, 1, 0, 6, "hostFrameLayout"); 

    nameEntry = new KLineEdit( hostFrame, "nameEntry" );

    hostFrameLayout->addMultiCellWidget( nameEntry, 0, 0, 1, 2 );

    textLabel2 = new QLabel( hostFrame, "textLabel2" );
    textLabel2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel2->sizePolicy().hasHeightForWidth() ) );
    textLabel2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addWidget( textLabel2, 1, 0 );

    addressEntry = new KLineEdit( hostFrame, "addressEntry" );

    hostFrameLayout->addMultiCellWidget( addressEntry, 1, 1, 1, 2 );

    textLabel1 = new QLabel( hostFrame, "textLabel1" );
    textLabel1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel1->sizePolicy().hasHeightForWidth() ) );
    textLabel1->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addWidget( textLabel1, 0, 0 );

    hostStack = new QWidgetStack( hostFrame, "hostStack" );

    WStackPage = new QWidget( hostStack, "WStackPage" );
    WStackPageLayout = new QVBoxLayout( WStackPage, 0, 0, "WStackPageLayout"); 
    spacer2 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    WStackPageLayout->addItem( spacer2 );
    hostStack->addWidget( WStackPage, 0 );

    WStackPage_2 = new QWidget( hostStack, "WStackPage_2" );
    WStackPageLayout_2 = new QVBoxLayout( WStackPage_2, 0, 0, "WStackPageLayout_2"); 

    groupBox2 = new QGroupBox( WStackPage_2, "groupBox2" );
    groupBox2->setColumnLayout(0, Qt::Vertical );
    groupBox2->layout()->setSpacing( 6 );
    groupBox2->layout()->setMargin( 11 );
    groupBox2Layout = new QGridLayout( groupBox2->layout() );
    groupBox2Layout->setAlignment( Qt::AlignTop );

    textLabel13 = new QLabel( groupBox2, "textLabel13" );
    textLabel13->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel13->sizePolicy().hasHeightForWidth() ) );
    textLabel13->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    groupBox2Layout->addWidget( textLabel13, 0, 0 );

    textLabel14 = new QLabel( groupBox2, "textLabel14" );
    textLabel14->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel14->sizePolicy().hasHeightForWidth() ) );
    textLabel14->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    groupBox2Layout->addWidget( textLabel14, 1, 0 );

    binaryEntry = new KLineEdit( groupBox2, "binaryEntry" );

    groupBox2Layout->addWidget( binaryEntry, 0, 1 );

    binaryButton = new KPushButton( groupBox2, "binaryButton" );

    groupBox2Layout->addWidget( binaryButton, 0, 2 );

    rootEntry = new KLineEdit( groupBox2, "rootEntry" );

    groupBox2Layout->addWidget( rootEntry, 1, 1 );

    rootButton = new KPushButton( groupBox2, "rootButton" );

    groupBox2Layout->addWidget( rootButton, 1, 2 );

    textLabel15 = new QLabel( groupBox2, "textLabel15" );
    textLabel15->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel15->sizePolicy().hasHeightForWidth() ) );
    textLabel15->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    groupBox2Layout->addWidget( textLabel15, 2, 0 );

    startupEntry = new KComboBox( FALSE, groupBox2, "startupEntry" );

    groupBox2Layout->addMultiCellWidget( startupEntry, 2, 2, 1, 2 );
    WStackPageLayout_2->addWidget( groupBox2 );
    spacer4 = new QSpacerItem( 20, 80, QSizePolicy::Minimum, QSizePolicy::Expanding );
    WStackPageLayout_2->addItem( spacer4 );
    hostStack->addWidget( WStackPage_2, 1 );

    hostFrameLayout->addMultiCellWidget( hostStack, 7, 7, 0, 2 );

    textLabel6 = new QLabel( hostFrame, "textLabel6" );
    textLabel6->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel6->sizePolicy().hasHeightForWidth() ) );
    textLabel6->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addMultiCellWidget( textLabel6, 6, 6, 0, 1 );

    passwordEntry = new KPasswordEdit( hostFrame, "passwordEntry" );

    hostFrameLayout->addWidget( passwordEntry, 5, 2 );

    textLabel5 = new QLabel( hostFrame, "textLabel5" );
    textLabel5->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel5->sizePolicy().hasHeightForWidth() ) );
    textLabel5->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addMultiCellWidget( textLabel5, 5, 5, 0, 1 );

    textLabel4 = new QLabel( hostFrame, "textLabel4" );
    textLabel4->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel4->sizePolicy().hasHeightForWidth() ) );
    textLabel4->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addMultiCellWidget( textLabel4, 4, 4, 0, 1 );

    usernameEntry = new KLineEdit( hostFrame, "usernameEntry" );

    hostFrameLayout->addWidget( usernameEntry, 4, 2 );

    hostModeEntry = new KComboBox( FALSE, hostFrame, "hostModeEntry" );

    hostFrameLayout->addWidget( hostModeEntry, 6, 2 );

    portEntry = new KIntNumInput( hostFrame, "portEntry" );
    portEntry->setValue( 4001 );
    portEntry->setMinValue( 0 );
    portEntry->setMaxValue( 65535 );

    hostFrameLayout->addMultiCellWidget( portEntry, 2, 2, 1, 2 );

    textLabel3 = new QLabel( hostFrame, "textLabel3" );
    textLabel3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel3->sizePolicy().hasHeightForWidth() ) );
    textLabel3->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addWidget( textLabel3, 2, 0 );

    textLabel3_2 = new QLabel( hostFrame, "textLabel3_2" );
    textLabel3_2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel3_2->sizePolicy().hasHeightForWidth() ) );
    textLabel3_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    hostFrameLayout->addWidget( textLabel3_2, 3, 0 );

    httpPortEntry = new KIntNumInput( hostFrame, "httpPortEntry" );
    httpPortEntry->setValue( 4080 );
    httpPortEntry->setMinValue( 0 );
    httpPortEntry->setMaxValue( 65535 );

    hostFrameLayout->addMultiCellWidget( httpPortEntry, 3, 3, 1, 2 );
    tabLayout->addWidget( hostFrame );
    tabWidget2->insertTab( tab, QString::fromLatin1("") );

    tab_2 = new QWidget( tabWidget2, "tab_2" );
    tabLayout_2 = new QGridLayout( tab_2, 1, 1, 11, 6, "tabLayout_2"); 

    mobilePasswordButton = new KPushButton( tab_2, "mobilePasswordButton" );
    mobilePasswordButton->setEnabled( FALSE );
    mobilePasswordButton->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, mobilePasswordButton->sizePolicy().hasHeightForWidth() ) );

    tabLayout_2->addWidget( mobilePasswordButton, 2, 2 );

    mobilePasswordState = new KLineEdit( tab_2, "mobilePasswordState" );
    mobilePasswordState->setEnabled( FALSE );
    mobilePasswordState->setReadOnly( TRUE );

    tabLayout_2->addWidget( mobilePasswordState, 2, 1 );

    textLabel8 = new QLabel( tab_2, "textLabel8" );
    textLabel8->setEnabled( FALSE );
    textLabel8->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel8->sizePolicy().hasHeightForWidth() ) );
    textLabel8->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    tabLayout_2->addWidget( textLabel8, 2, 0 );

    textLabel7 = new QLabel( tab_2, "textLabel7" );
    textLabel7->setEnabled( FALSE );
    textLabel7->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel7->sizePolicy().hasHeightForWidth() ) );
    textLabel7->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    tabLayout_2->addWidget( textLabel7, 1, 0 );

    mobilePortEntry = new KIntNumInput( tab_2, "mobilePortEntry" );
    mobilePortEntry->setEnabled( FALSE );
    mobilePortEntry->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, mobilePortEntry->sizePolicy().hasHeightForWidth() ) );
    mobilePortEntry->setValue( 4081 );
    mobilePortEntry->setMinValue( 0 );
    mobilePortEntry->setMaxValue( 65535 );

    tabLayout_2->addMultiCellWidget( mobilePortEntry, 1, 1, 1, 2 );

    mobileToggle = new QCheckBox( tab_2, "mobileToggle" );

    tabLayout_2->addMultiCellWidget( mobileToggle, 0, 0, 0, 2 );
    spacer1 = new QSpacerItem( 500, 380, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout_2->addMultiCell( spacer1, 3, 3, 0, 2 );
    tabWidget2->insertTab( tab_2, QString::fromLatin1("") );
    DonkeyConfigLayout->addWidget( tabWidget2 );
    languageChange();
    resize( QSize(726, 624).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( hostModeEntry, SIGNAL( activated(int) ), hostStack, SLOT( raiseWidget(int) ) );
    connect( mobileToggle, SIGNAL( toggled(bool) ), mobilePortEntry, SLOT( setEnabled(bool) ) );
    connect( mobileToggle, SIGNAL( toggled(bool) ), mobilePasswordState, SLOT( setEnabled(bool) ) );
    connect( mobileToggle, SIGNAL( toggled(bool) ), mobilePasswordButton, SLOT( setEnabled(bool) ) );
    connect( mobileToggle, SIGNAL( toggled(bool) ), textLabel7, SLOT( setEnabled(bool) ) );
    connect( mobileToggle, SIGNAL( toggled(bool) ), textLabel8, SLOT( setEnabled(bool) ) );
    connect( mobileToggle, SIGNAL( clicked() ), this, SLOT( configChanged() ) );
    connect( mobilePortEntry, SIGNAL( valueChanged(int) ), this, SLOT( configChanged() ) );
    connect( hostList, SIGNAL( highlighted(QListBoxItem*) ), this, SLOT( entrySelected(QListBoxItem*) ) );
    connect( binaryButton, SIGNAL( clicked() ), this, SLOT( binaryPathDialog() ) );
    connect( rootButton, SIGNAL( clicked() ), this, SLOT( rootPathDialog() ) );
    connect( defaultButton, SIGNAL( clicked() ), this, SLOT( defaultButtonClicked() ) );
    connect( newButton, SIGNAL( clicked() ), this, SLOT( newButtonClicked() ) );
    connect( deleteButton, SIGNAL( clicked() ), this, SLOT( deleteButtonClicked() ) );
    connect( nameEntry, SIGNAL( textChanged(const QString&) ), this, SLOT( nameChanged(const QString&) ) );
    connect( addressEntry, SIGNAL( textChanged(const QString&) ), this, SLOT( addressChanged(const QString&) ) );
    connect( portEntry, SIGNAL( valueChanged(int) ), this, SLOT( portChanged(int) ) );
    connect( usernameEntry, SIGNAL( textChanged(const QString&) ), this, SLOT( usernameChanged(const QString&) ) );
    connect( passwordEntry, SIGNAL( textChanged(const QString&) ), this, SLOT( passwordChanged(const QString&) ) );
    connect( hostModeEntry, SIGNAL( activated(int) ), this, SLOT( hostModeChanged(int) ) );
    connect( binaryEntry, SIGNAL( textChanged(const QString&) ), this, SLOT( binaryChanged(const QString&) ) );
    connect( rootEntry, SIGNAL( textChanged(const QString&) ), this, SLOT( rootChanged(const QString&) ) );
    connect( mobilePasswordButton, SIGNAL( clicked() ), this, SLOT( newMobilePassword() ) );
    connect( startupEntry, SIGNAL( activated(int) ), this, SLOT( startupModeChanged(int) ) );
    connect( httpPortEntry, SIGNAL( valueChanged(int) ), this, SLOT( httpPortChanged(int) ) );

    // tab order
    setTabOrder( tabWidget2, hostList );
    setTabOrder( hostList, defaultButton );
    setTabOrder( defaultButton, newButton );
    setTabOrder( newButton, deleteButton );
    setTabOrder( deleteButton, nameEntry );
    setTabOrder( nameEntry, addressEntry );
    setTabOrder( addressEntry, portEntry );
    setTabOrder( portEntry, httpPortEntry );
    setTabOrder( httpPortEntry, usernameEntry );
    setTabOrder( usernameEntry, passwordEntry );
    setTabOrder( passwordEntry, hostModeEntry );
    setTabOrder( hostModeEntry, binaryEntry );
    setTabOrder( binaryEntry, binaryButton );
    setTabOrder( binaryButton, rootEntry );
    setTabOrder( rootEntry, rootButton );
    setTabOrder( rootButton, startupEntry );
    setTabOrder( startupEntry, mobileToggle );
    setTabOrder( mobileToggle, mobilePortEntry );
    setTabOrder( mobilePortEntry, mobilePasswordState );
    setTabOrder( mobilePasswordState, mobilePasswordButton );

    // buddies
    textLabel2->setBuddy( addressEntry );
    textLabel1->setBuddy( nameEntry );
    textLabel13->setBuddy( binaryEntry );
    textLabel14->setBuddy( rootEntry );
    textLabel15->setBuddy( startupEntry );
    textLabel6->setBuddy( hostModeEntry );
    textLabel5->setBuddy( passwordEntry );
    textLabel4->setBuddy( usernameEntry );
    textLabel3->setBuddy( portEntry );
    textLabel3_2->setBuddy( httpPortEntry );
    textLabel7->setBuddy( mobilePortEntry );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
DonkeyConfig::~DonkeyConfig()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void DonkeyConfig::languageChange()
{
    setCaption( tr2i18n( "KMLDonkey Configuration" ) );
    defaultButton->setText( QString::null );
    defaultButton->setAccel( QKeySequence( QString::null ) );
    newButton->setText( QString::null );
    newButton->setAccel( QKeySequence( QString::null ) );
    deleteButton->setText( QString::null );
    deleteButton->setAccel( QKeySequence( QString::null ) );
    textLabel2->setText( tr2i18n( "&Address:" ) );
    textLabel1->setText( tr2i18n( "&Name:" ) );
    groupBox2->setTitle( tr2i18n( "Managed Core Settings" ) );
    textLabel13->setText( tr2i18n( "Path to &mlnet:" ) );
    textLabel14->setText( tr2i18n( "Donkey &root:" ) );
    binaryButton->setText( QString::null );
    rootButton->setText( QString::null );
    textLabel15->setText( tr2i18n( "&Startup mode:" ) );
    startupEntry->clear();
    startupEntry->insertItem( tr2i18n( "When logged in" ) );
    startupEntry->insertItem( tr2i18n( "When KMLDonkey is running" ) );
    textLabel6->setText( tr2i18n( "Core t&ype:" ) );
    textLabel5->setText( tr2i18n( "Pass&word:" ) );
    textLabel4->setText( tr2i18n( "&User name:" ) );
    hostModeEntry->clear();
    hostModeEntry->insertItem( tr2i18n( "External core" ) );
    hostModeEntry->insertItem( tr2i18n( "Managed core" ) );
    textLabel3->setText( tr2i18n( "GUI &port:" ) );
    textLabel3_2->setText( tr2i18n( "&HTTP port:" ) );
    tabWidget2->changeTab( tab, tr2i18n( "Cores" ) );
    mobilePasswordButton->setText( tr2i18n( "&Change..." ) );
    textLabel8->setText( tr2i18n( "Password:" ) );
    textLabel7->setText( tr2i18n( "&Port:" ) );
    mobileToggle->setText( tr2i18n( "&Activate MobileMule" ) );
    tabWidget2->changeTab( tab_2, tr2i18n( "MobileMule" ) );
}

#include "donkeyconfig.moc"
