/****************************************************************************
** Form interface generated from reading ui file './donkeyconfig.ui'
**
** Created: Thu Nov 13 01:47:36 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef DONKEYCONFIG_H
#define DONKEYCONFIG_H

#include <qvariant.h>
#include <qwidget.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QTabWidget;
class KListBox;
class QListBoxItem;
class KPushButton;
class QFrame;
class KLineEdit;
class QLabel;
class QWidgetStack;
class QGroupBox;
class KComboBox;
class KPasswordEdit;
class KIntNumInput;
class QCheckBox;
class DonkeyEntry;

class DonkeyConfig : public QWidget
{
    Q_OBJECT

public:
    DonkeyConfig( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~DonkeyConfig();

    QTabWidget* tabWidget2;
    QWidget* tab;
    KListBox* hostList;
    KPushButton* defaultButton;
    KPushButton* newButton;
    KPushButton* deleteButton;
    QFrame* hostFrame;
    KLineEdit* nameEntry;
    QLabel* textLabel2;
    KLineEdit* addressEntry;
    QLabel* textLabel1;
    QWidgetStack* hostStack;
    QWidget* WStackPage;
    QWidget* WStackPage_2;
    QGroupBox* groupBox2;
    QLabel* textLabel13;
    QLabel* textLabel14;
    KLineEdit* binaryEntry;
    KPushButton* binaryButton;
    KLineEdit* rootEntry;
    KPushButton* rootButton;
    QLabel* textLabel15;
    KComboBox* startupEntry;
    QLabel* textLabel6;
    KPasswordEdit* passwordEntry;
    QLabel* textLabel5;
    QLabel* textLabel4;
    KLineEdit* usernameEntry;
    KComboBox* hostModeEntry;
    KIntNumInput* portEntry;
    QLabel* textLabel3;
    QLabel* textLabel3_2;
    KIntNumInput* httpPortEntry;
    QWidget* tab_2;
    KPushButton* mobilePasswordButton;
    KLineEdit* mobilePasswordState;
    QLabel* textLabel8;
    QLabel* textLabel7;
    KIntNumInput* mobilePortEntry;
    QCheckBox* mobileToggle;

    virtual void save();
    virtual void load( bool defaults );

public slots:
    virtual void httpPortChanged( int value );

signals:
    void changed(bool);

protected:
    QVBoxLayout* DonkeyConfigLayout;
    QHBoxLayout* tabLayout;
    QVBoxLayout* layout1;
    QGridLayout* hostFrameLayout;
    QVBoxLayout* WStackPageLayout;
    QSpacerItem* spacer2;
    QVBoxLayout* WStackPageLayout_2;
    QSpacerItem* spacer4;
    QGridLayout* groupBox2Layout;
    QGridLayout* tabLayout_2;
    QSpacerItem* spacer1;

protected slots:
    virtual void languageChange();

private:
    DonkeyEntry* m_active;
    DonkeyEntry* m_default;
    QString m_mobilePassword;
    bool m_processSignals;

    void init();
    virtual void setDefaultEntry( DonkeyEntry * entry );
    virtual DonkeyEntry * getActiveEntry();
    virtual bool startMobileMuleService( bool start );

private slots:
    virtual void configChanged();
    virtual void entrySelected( QListBoxItem * item );
    virtual void nameChanged( const QString & text );
    virtual void addressChanged( const QString & text );
    virtual void usernameChanged( const QString & text );
    virtual void passwordChanged( const QString & );
    virtual void portChanged( int value );
    virtual void hostModeChanged( int value );
    virtual void binaryChanged( const QString & value );
    virtual void rootChanged( const QString & value );
    virtual void startupModeChanged( int value );
    virtual void defaultButtonClicked();
    virtual void newButtonClicked();
    virtual void deleteButtonClicked();
    virtual void rootPathDialog();
    virtual void binaryPathDialog();
    virtual void newMobilePassword();

};

#endif // DONKEYCONFIG_H
