#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './generalpage.ui'
**
** Created: Thu Nov 13 01:45:24 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "generalpage.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <kcombobox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kcombobox.h"
#include "kglobal.h"
#include "kcharsets.h"
#include "kmessagebox.h"
#include "kmldonkey.h"
#include "donkeyprotocol.h"
#include "./generalpage.ui.h"

/*
 *  Constructs a KMLDonkeyPrefGeneralPage as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMLDonkeyPrefGeneralPage::KMLDonkeyPrefGeneralPage( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMLDonkeyPrefGeneralPage" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)1, 0, 0, sizePolicy().hasHeightForWidth() ) );
    KMLDonkeyPrefGeneralPageLayout = new QVBoxLayout( this, 11, 6, "KMLDonkeyPrefGeneralPageLayout"); 

    groupBox1 = new QGroupBox( this, "groupBox1" );
    groupBox1->setColumnLayout(0, Qt::Vertical );
    groupBox1->layout()->setSpacing( 6 );
    groupBox1->layout()->setMargin( 11 );
    groupBox1Layout = new QVBoxLayout( groupBox1->layout() );
    groupBox1Layout->setAlignment( Qt::AlignTop );

    showToolbarCheckbox = new QCheckBox( groupBox1, "showToolbarCheckbox" );
    groupBox1Layout->addWidget( showToolbarCheckbox );

    showStatusbarCheckbox = new QCheckBox( groupBox1, "showStatusbarCheckbox" );
    groupBox1Layout->addWidget( showStatusbarCheckbox );

    statusbarLabelsCheckbox = new QCheckBox( groupBox1, "statusbarLabelsCheckbox" );
    groupBox1Layout->addWidget( statusbarLabelsCheckbox );

    persistentReconnectCheckbox = new QCheckBox( groupBox1, "persistentReconnectCheckbox" );
    groupBox1Layout->addWidget( persistentReconnectCheckbox );

    showTrayiconCheckBox = new QCheckBox( groupBox1, "showTrayiconCheckBox" );
    groupBox1Layout->addWidget( showTrayiconCheckBox );

    showTrayOnCloseCheckBox = new QCheckBox( groupBox1, "showTrayOnCloseCheckBox" );
    groupBox1Layout->addWidget( showTrayOnCloseCheckBox );
    KMLDonkeyPrefGeneralPageLayout->addWidget( groupBox1 );

    groupBox2 = new QGroupBox( this, "groupBox2" );
    groupBox2->setColumnLayout(0, Qt::Vertical );
    groupBox2->layout()->setSpacing( 6 );
    groupBox2->layout()->setMargin( 11 );
    groupBox2Layout = new QGridLayout( groupBox2->layout() );
    groupBox2Layout->setAlignment( Qt::AlignTop );

    saveStateCheckbox = new QCheckBox( groupBox2, "saveStateCheckbox" );

    groupBox2Layout->addMultiCellWidget( saveStateCheckbox, 1, 1, 0, 1 );

    encodingSelector = new KComboBox( FALSE, groupBox2, "encodingSelector" );

    groupBox2Layout->addWidget( encodingSelector, 0, 1 );

    encodingLabel = new QLabel( groupBox2, "encodingLabel" );
    encodingLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)5, 0, 0, encodingLabel->sizePolicy().hasHeightForWidth() ) );

    groupBox2Layout->addWidget( encodingLabel, 0, 0 );

    enableStatsCheckbox = new QCheckBox( groupBox2, "enableStatsCheckbox" );

    groupBox2Layout->addMultiCellWidget( enableStatsCheckbox, 2, 2, 0, 1 );

    debugConsoleCheckbox = new QCheckBox( groupBox2, "debugConsoleCheckbox" );

    groupBox2Layout->addMultiCellWidget( debugConsoleCheckbox, 3, 3, 0, 1 );

    advancedConfigCheckbox = new QCheckBox( groupBox2, "advancedConfigCheckbox" );

    groupBox2Layout->addMultiCellWidget( advancedConfigCheckbox, 4, 4, 0, 1 );
    KMLDonkeyPrefGeneralPageLayout->addWidget( groupBox2 );
    spacer1 = new QSpacerItem( 280, 50, QSizePolicy::Minimum, QSizePolicy::Expanding );
    KMLDonkeyPrefGeneralPageLayout->addItem( spacer1 );
    languageChange();
    resize( QSize(590, 488).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( encodingSelector, SIGNAL( activated(int) ), this, SLOT( encodingSelectionChanged(int) ) );

    // tab order
    setTabOrder( showToolbarCheckbox, showStatusbarCheckbox );
    setTabOrder( showStatusbarCheckbox, statusbarLabelsCheckbox );
    setTabOrder( statusbarLabelsCheckbox, persistentReconnectCheckbox );
    setTabOrder( persistentReconnectCheckbox, encodingSelector );
    setTabOrder( encodingSelector, saveStateCheckbox );
    setTabOrder( saveStateCheckbox, debugConsoleCheckbox );

    // buddies
    encodingLabel->setBuddy( encodingSelector );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMLDonkeyPrefGeneralPage::~KMLDonkeyPrefGeneralPage()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMLDonkeyPrefGeneralPage::languageChange()
{
    setCaption( tr2i18n( "General Preferences" ) );
    groupBox1->setTitle( tr2i18n( "Interface Settings" ) );
    showToolbarCheckbox->setText( tr2i18n( "Show the &toolbar" ) );
    showStatusbarCheckbox->setText( tr2i18n( "Show the &status bar" ) );
    statusbarLabelsCheckbox->setText( tr2i18n( "Show &labels in the status bar" ) );
    persistentReconnectCheckbox->setText( tr2i18n( "Always stay &connected" ) );
    QToolTip::add( persistentReconnectCheckbox, tr2i18n( "If connection to the core fails or is lost, should KMLDonkey keep trying to reestablish contact until it succeeds?" ) );
    showTrayiconCheckBox->setText( tr2i18n( "Show tray icon" ) );
    showTrayOnCloseCheckBox->setText( tr2i18n( "Minimize to tray icon on close" ) );
    groupBox2->setTitle( tr2i18n( "Advanced Settings" ) );
    saveStateCheckbox->setText( tr2i18n( "Sa&ve state on exit" ) );
    QToolTip::add( saveStateCheckbox, tr2i18n( "If this is enabled, KMLDonkey remembers its state between restarts. Think twice before disabling this." ) );
    QToolTip::add( encodingSelector, tr2i18n( "The character set to use to decode the strings sent to us by the core." ) );
    QWhatsThis::add( encodingSelector, tr2i18n( "<p>Although MLDonkey does not understand about character encodings, you may well encounter text on the Donkey network that has been encoded in various national character sets. While you should, in general, use the ISO 8859-1 encoding - the de-facto network standard - you can choose a different character encoding here if you expect most of the text you encounter to be encoded in a certain national character set.</p>\n"
"<p><b>Note:</b> Changing this causes KMLDonkey to reconnect to the core. Changing it to something incompatible with the ISO 8859-1 character set <em>may</em> cause unpredictable behavior.</p>\n"
"" ) );
    encodingLabel->setText( tr2i18n( "Text &encoding:" ) );
    enableStatsCheckbox->setText( tr2i18n( "Enable st&atistics" ) );
    QToolTip::add( enableStatsCheckbox, tr2i18n( "Enable the statistics page" ) );
    debugConsoleCheckbox->setText( tr2i18n( "Enable the &debug console" ) );
    QToolTip::add( debugConsoleCheckbox, tr2i18n( "Show the debug console: you will not ever need this unless you are a KMLDonkey developer." ) );
    advancedConfigCheckbox->setText( tr2i18n( "Enable &advanced configuration options" ) );
    QToolTip::add( advancedConfigCheckbox, tr2i18n( "Enable the advanced MLDonkey configuration dialog that lets you configure more MLDonkey options." ) );
}

#include "generalpage.moc"
