#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './searchpage.ui'
**
** Created: Thu Nov 13 01:45:28 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "searchpage.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMLDonkeyPrefSearchPage as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMLDonkeyPrefSearchPage::KMLDonkeyPrefSearchPage( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMLDonkeyPrefSearchPage" );
    KMLDonkeyPrefSearchPageLayout = new QVBoxLayout( this, 11, 6, "KMLDonkeyPrefSearchPageLayout"); 

    groupBox3 = new QGroupBox( this, "groupBox3" );
    groupBox3->setColumnLayout(0, Qt::Vertical );
    groupBox3->layout()->setSpacing( 6 );
    groupBox3->layout()->setMargin( 11 );
    groupBox3Layout = new QVBoxLayout( groupBox3->layout() );
    groupBox3Layout->setAlignment( Qt::AlignTop );

    activateNewTabsCheckbox = new QCheckBox( groupBox3, "activateNewTabsCheckbox" );
    groupBox3Layout->addWidget( activateNewTabsCheckbox );

    closeTabsOnDisconnectCheckbox = new QCheckBox( groupBox3, "closeTabsOnDisconnectCheckbox" );
    groupBox3Layout->addWidget( closeTabsOnDisconnectCheckbox );

    showNumbersOnTabsCheckbox = new QCheckBox( groupBox3, "showNumbersOnTabsCheckbox" );
    groupBox3Layout->addWidget( showNumbersOnTabsCheckbox );

    showSubmitURLCheckbox = new QCheckBox( groupBox3, "showSubmitURLCheckbox" );
    groupBox3Layout->addWidget( showSubmitURLCheckbox );
    KMLDonkeyPrefSearchPageLayout->addWidget( groupBox3 );
    spacer3 = new QSpacerItem( 81, 81, QSizePolicy::Minimum, QSizePolicy::Expanding );
    KMLDonkeyPrefSearchPageLayout->addItem( spacer3 );
    languageChange();
    resize( QSize(600, 480).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMLDonkeyPrefSearchPage::~KMLDonkeyPrefSearchPage()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMLDonkeyPrefSearchPage::languageChange()
{
    setCaption( tr2i18n( "Search Configuration" ) );
    groupBox3->setTitle( tr2i18n( "Search Settings" ) );
    activateNewTabsCheckbox->setText( tr2i18n( "Open new search pages in &front" ) );
    QToolTip::add( activateNewTabsCheckbox, tr2i18n( "When a new search is started, open the search page in front of any other pages." ) );
    closeTabsOnDisconnectCheckbox->setText( tr2i18n( "&Close search pages on disconnect" ) );
    QToolTip::add( closeTabsOnDisconnectCheckbox, tr2i18n( "Close all open searches if KMLDonkey is disconnected from the core." ) );
    showNumbersOnTabsCheckbox->setText( tr2i18n( "Show number of search &results in tab title" ) );
    showSubmitURLCheckbox->setText( tr2i18n( "Show the \"Submit &URL\" entry box" ) );
}

#include "searchpage.moc"
